<template>
  <div>
    <q-table
      card-class="super-rounded-borders"
      table-header-class="text-grey"
      :pagination.sync="pagination"
      :loading="loading"
      :columns="columns"
      :data="tableData"
      :filter="filter"
      color="primary"
      row-key="id"
      bordered
      dense
      flat
    >
      <template v-slot:top-left>
        <div
          class="text-h6 text-accent q-pa-md"
          v-text="title"
        />
      </template>

      <template v-slot:top-right>
        <q-input
          v-model="filter"
          class="q-py-md q-px-xs"
          placeholder="Buscar"
          color="primary"
          debounce="300"
          outlined
          dense
        >
          <template v-slot:append>
            <q-icon name="search" />
          </template>
        </q-input>
      </template>

      <template v-slot:body-cell="props">
        <q-td :props="props">
          <div
            :class="{ 'text-strike text-grey': !props.row.isEnable }"
            v-text="props.value"
          />
        </q-td>
      </template>

      <template v-slot:body-cell-avatar="props">
        <q-td :props="props">
          <q-btn
            v-if="props.value"
            :icon="`img:${generateDownloadURL('usuarios', props.value)}`"
            :href="generateDownloadURL('usuarios', props.value)"
            target="_blank"
            color="white"
            size="12px"
            type="a"
            round
            dense
            flat
          />
        </q-td>
      </template>

      <template v-slot:body-cell-action="props">
        <q-td :props="props">
          <q-btn
            class="q-mr-sm"
            :to="{ name: 'profile', params: { userId: props.row.id } }"
            icon="fas fa-edit"
            color="primary"
            size="sm"
            round
            dense
            flat
          >
            <q-tooltip
              content-class="text-caption text-bold bg-primary super-rounded-borders q-py-none"
              transition-show="fade"
              transition-hide="fade"
              anchor="center left"
              self="center right"
            >
              <div v-text="'Editar'" />
            </q-tooltip>
          </q-btn>

          <q-btn
            :icon="props.row.isEnable ? 'fas fa-toggle-on' : 'fas fa-toggle-off'"
            color="primary"
            size="sm"
            round
            dense
            flat
            @click="disable(props.row)"
          >
            <q-tooltip
              content-class="text-caption text-bold bg-primary super-rounded-borders q-py-none"
              transition-show="fade"
              transition-hide="fade"
              anchor="center right"
              self="center left"
            >
              <div v-text="props.row.isEnable ? 'Desativar' : 'Ativar'" />
            </q-tooltip>
          </q-btn>
        </q-td>
      </template>
    </q-table>
  </div>
</template>

<script>
import { GenerateDownloadURLMixin } from '../../mixin/generate-download-url'

export default {
  name: 'TableView',
  mixins: [GenerateDownloadURLMixin],
  props: {
    columns: {
      type: Array,
      required: true
    },
    tableData: {
      type: Array,
      required: true
    },
    title: {
      type: String,
      default: () => ('')
    },
    sortBy: {
      type: String,
      required: true
    }
  },
  data () {
    return {
      pagination: {
        sortBy: this.sortBy,
        descending: false,
        rowsPerPage: 15,
        page: 1
      },
      loading: false,
      filter: ''
    }
  },
  methods: {
    async disable ({ id, isEnable }) {
      this.$q.loading.show()

      try {
        const axiosConfig = {
          method: 'PATCH',
          url: `/Usuarios/${id}`,
          data: { isEnable: !isEnable }
        }

        await this.$axios(axiosConfig)

        this.axiosSuccess('Salvo com sucesso')
      } catch (err) {
        this.axiosCatch(err)
      } finally {
        this.$q.loading.hide()
        this.$emit('reload')
      }
    }
  }
}
</script>
